

CREATE OR REPLACE Function spBoM_New (
	_BoMID		VARCHAR
) RETURNS SETOF SPStatus AS 
$BODY$
DECLARE	
	_retval		SPStatus%ROWTYPE;


	_ItemID		VARCHAR;
	_ItemID2	VARCHAR;
	_sumCost	NUMERIC(19,4);
	_BomDNo		INT2;
	_WHID		VARCHAR;
	_PID		VARCHAR;
	_Unit		VARCHAR;
	_Qty		NUMERIC(15,4);
	_Cost		NUMERIC(19,4);
	_bomdpercent	NUMERIC(19,4);

	_ItemUnit1	VARCHAR;
	_ItemUnit2	VARCHAR;
	_ItemUnit3	VARCHAR;
	cBomD		REFCURSOR;
BEGIN

	SELECT INTO _ItemID, _PID, _Unit itemid, pid, unit FROM bom WHERE bomid=_BoMID;
	IF (NOT FOUND OR _ItemID IS NULL) THEN
		_retval.ErrNo:=50555;
		_retval.ErrMsg:='BoM# '||_BoMID||' tidak ditemukan (spBoM_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF; 

/**	SELECT INTO _ItemUnit1, _ItemUnit2, _ItemUnit3 unit1,unit2,unit3 FROM item WHERE itemid=_ItemID;
	IF (_Unit<>_ItemUnit1 OR (_ItemUnit2 IS NOT NULL AND _Unit<>_ItemUnit2) OR (_ItemUnit3 IS NOT NULL AND _Unit<>_ItemUnit3)) THEN
		_retval.ErrNo:=50555;
		_retval.ErrMsg:='Unit# '||_Unit||' pada Item# '||_ItemID||' tidak ditemukan  (spBoM_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;
*/
	SELECT INTO _ItemID2 itemid FROM bomd WHERE bomid=_BoMID AND itemid=_ItemID; 
	IF (_ItemID2=_ItemID) THEN
		_retval.ErrNo:=50555;
		_retval.ErrMsg:='Item Output tidak boleh sama dengan Item Input (spBoM_New)';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;

	SELECT INTO _ItemID2 itemid FROM bom 
	WHERE bomid<>_BoMID 
	AND itemid=_ItemID
	AND pid=_PID
	AND Active=TRUE;

	IF (_ItemID2=_ItemID) THEN
		_retval.ErrNo:=50555;
		_retval.ErrMsg:='Ada B.o.M lain yang masih Aktif. In-Aktifkan B.o.M yang lama terlebih dahulu !!';
		RAISE EXCEPTION '%', _retval.ErrMsg;
	END IF;
	

	/*UPDATE BoM SET TotStdCost=(SELECT SUM(Qty*StdCost) FROM BoMD WHERE BoMID=_BoMID) WHERE BoMID=_BoMID;	*/

	_retval:=(0,'OK');
	RETURN NEXT _retval;
END;
$BODY$ 
LANGUAGE 'plpgsql' VOLATILE;


